package com.fp.persistence.pcustomer.balance;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TCUSTBALANCEACCOUNT*/
@Embeddable
public class TcustBalanceAccountKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="ACCOUNTCODE", nullable=false,updatable=false)

/**
* Codigo de la cuenta de balance
*/
private String accountcode;

@Column(name="BALANCECATALOG", nullable=false,updatable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String balancecatalog;

@Column(name="BALANCECATALOGCODE", nullable=false,updatable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String balancecatalogcode;

/**Contructor por defecto*/
public TcustBalanceAccountKey(){}
/**Contructor de TcustBalanceAccountKey
@param pAccountcode Codigo de la cuenta de balance
@param pBalancecatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pBalancecatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
public TcustBalanceAccountKey(String pAccountcode,String pBalancecatalog,String pBalancecatalogcode){
 accountcode=pAccountcode;
 balancecatalog=pBalancecatalog;
 balancecatalogcode=pBalancecatalogcode;
}
/**Obtiene el valor de accountcode
@return valor de accountcode*/
public String getAccountcode(){
  return accountcode;
}
/**Fija el valor de accountcode
@param pAccountcode nuevo Valor de accountcode*/
public void setAccountcode(String pAccountcode){
  accountcode=pAccountcode;
}

/**Obtiene el valor de balancecatalog
@return valor de balancecatalog*/
public String getBalancecatalog(){
  return balancecatalog;
}
/**Fija el valor de balancecatalog
@param pBalancecatalog nuevo Valor de balancecatalog*/
public void setBalancecatalog(String pBalancecatalog){
  balancecatalog=pBalancecatalog;
}

/**Obtiene el valor de balancecatalogcode
@return valor de balancecatalogcode*/
public String getBalancecatalogcode(){
  return balancecatalogcode;
}
/**Fija el valor de balancecatalogcode
@param pBalancecatalogcode nuevo Valor de balancecatalogcode*/
public void setBalancecatalogcode(String pBalancecatalogcode){
  balancecatalogcode=pBalancecatalogcode;
}

/**Implementacion de la comparacion de TcustBalanceAccountKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TcustBalanceAccountKey))return false;
  TcustBalanceAccountKey that = (TcustBalanceAccountKey) o;
  if (this.getAccountcode() == null || that.getAccountcode() == null){
      return false;
  }
  if (! this.getAccountcode().equals(that.getAccountcode())){
    return false;
  }
  if (this.getBalancecatalog() == null || that.getBalancecatalog() == null){
      return false;
  }
  if (! this.getBalancecatalog().equals(that.getBalancecatalog())){
    return false;
  }
  if (this.getBalancecatalogcode() == null || that.getBalancecatalogcode() == null){
      return false;
  }
  if (! this.getBalancecatalogcode().equals(that.getBalancecatalogcode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TcustBalanceAccountKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getAccountcode() == null ? 0 : this.getAccountcode().hashCode());
    result = result * 37 + (this.getBalancecatalog() == null ? 0 : this.getBalancecatalog().hashCode());
    result = result * 37 + (this.getBalancecatalogcode() == null ? 0 : this.getBalancecatalogcode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
